VirtualBox

source: vbox/trunk/configure@ 43138

Last change on this file since 43138 was 42002, checked in by vboxsync, 12 years ago

configure: if java is disabled, don't try to build the java webservice client

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 70.2 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2012 Oracle Corporation
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License (GPL) as published by the Free Software
12# Foundation, in version 2 as it comes in the "COPYING" file of the
13# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
14# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr [:upper:] [:lower:]`
47case "$OS" in
48 linux)
49 ;;
50 darwin)
51 ;;
52 freebsd)
53 ;;
54 sunos)
55 OS='solaris'
56 ;;
57 *)
58 echo "Cannot determine OS!"
59 exit 1
60 ;;
61esac
62
63#
64# Defaults
65#
66OSE=1
67ODIR="`pwd`/"
68ODIR_OVERRIDE=0
69OUT_PATH=""
70OUT_PATH_OVERRIDE=0
71SETUP_WINE=
72TARGET_MACHINE=""
73TARGET_CPU=""
74WITH_XPCOM=1
75WITH_PYTHON=1
76WITH_JAVA=1
77WITH_VMMRAW=1
78WITH_LIBIDL=1
79WITH_GSOAP=0
80WITH_QT4=1
81WITH_SDL=1
82WITH_SDL_TTF=1
83WITH_X11=1
84WITH_ALSA=1
85WITH_PULSE=1
86WITH_DBUS=1
87WITH_KMODS=1
88WITH_OPENGL=1
89WITH_HARDENING=1
90WITH_UDPTUNNEL=1
91WITH_VDE=0
92WITH_VNC=0
93WITH_EXTPACK=1
94WITH_DOCS=1
95BUILD_LIBXML2=
96BUILD_LIBCURL=
97BUILD_LIBSSL=
98PASSIVE_MESA=0
99CC="gcc"
100CC32=""
101CC64=""
102CXX="g++"
103CXX32=""
104CXX64=""
105BCC="bcc"
106YASM="yasm"
107IASL="iasl"
108AS86="as86"
109XSLTPROC="xsltproc"
110GENISOIMAGE="genisoimage"
111MKISOFS="mkisofs"
112INCCRYPTO=""
113LIBCRYPTO="-lssl -lcrypto"
114LIBPTHREAD="-lpthread"
115LIBCAP="-lcap"
116GSOAP=""
117GSOAP_IMPORT=""
118INCX11="/usr/local/include"
119LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
120LIBXCURSOR="-lXcursor"
121LIBXMU="-lXmu"
122LIBXINERAMA="-lXinerama"
123LIBXRANDR="-lXrandr"
124MAKESELF="makeself"
125MESA="-lGL"
126INCZ=""
127LIBZ="-lz"
128INCVNCSERVER=""
129LIBVNCSERVER="-lvncserver"
130CXX_FLAGS=""
131if [ "$OS" = "freebsd" ]; then
132 INCCURL="-I/usr/local/include"
133 LIBCURL="-L/usr/local/lib -lcurl"
134 INCPULSE="-I/usr/local/include"
135 LIBPULSE="-L/usr/local/lib"
136 INCPNG="-I/usr/local/include"
137 LIBPNG="-L/usr/local/lib -lpng"
138else
139 INCCURL=""
140 LIBCURL="-lcurl"
141 INCPNG=""
142 LIBPNG="-lpng"
143fi
144PKGCONFIG="`which_wrapper pkg-config`"
145PYTHONDIR="/usr /usr/local"
146QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr /usr/local"
147QT4DIR_PKGCONFIG=1
148QT4UIC3DIR="/usr/bin"
149KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
150DEVDIR="`cd \`dirname $0\`; pwd`/tools"
151if [ -d "/lib/modules/`uname -r`/build" ]; then
152 LINUX="/lib/modules/`uname -r`/build"
153else
154 LINUX="/usr/src/linux"
155fi
156KCHMVIEWER="kchmviewer"
157LOG="configure.log"
158CNF="AutoConfig.kmk"
159ENV="env.sh"
160BUILD_TYPE="release"
161# the restricting tool is ar (mri mode).
162INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
163
164if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
165 echo "Error: VBox base path contains invalid characters!"
166 exit 1
167fi
168
169# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
170if [ "$OS" = "darwin" ]; then
171 ECHO_N="/bin/echo -n"
172else
173 ECHO_N="echo -n"
174fi
175
176
177cleanup()
178{
179 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
180}
181
182fail()
183{
184 if [ -z "$nofatal" -o "x$1" != "x" ]; then
185 cleanup
186 rm -f $ENV
187 echo "Check $LOG for details"
188 exit 1
189 fi
190}
191
192log()
193{
194 echo "$1"
195 echo "$1" >> $LOG
196}
197
198log_success()
199{
200 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
201 echo "OK."
202 echo "$1" >> $LOG
203 echo >> $LOG
204 echo >> $LOG
205}
206
207log_failure()
208{
209 echo
210 echo " ** $1!"
211 echo "** $1!" >> $LOG
212 echo >> $LOG
213}
214
215cnf_append()
216{
217 printf "%-30s := %s\n" "$1" "$2" >> $CNF
218}
219
220strip_l()
221{
222 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
223}
224
225strip_L()
226{
227 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
228}
229
230strip_I()
231{
232 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
233}
234
235prefix_I()
236{
237 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
238}
239
240check_avail()
241{
242 if [ -z "$1" ]; then
243 log_failure "$2 is empty"
244 fail $3
245 return 1
246 elif which_wrapper $1 > /dev/null; then
247 return 0
248 else
249 log_failure "$1 (variable $2) not found"
250 fail $3
251 return 1
252 fi
253}
254
255
256# Prepare a test
257test_header()
258{
259 echo "***** Checking $1 *****" >> $LOG
260 $ECHO_N "Checking for $1: "
261}
262
263
264# Compile a test
265# $1 compile flags/libs
266# $2 library name
267# $3 package name
268# $4 if this argument is 'nofatal', don't abort
269test_compile()
270{
271 echo "compiling the following source file:" >> $LOG
272 cat $ODIR.tmp_src.cc >> $LOG
273 echo "using the following command line:" >> $LOG
274 echo "$CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
275 $CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
276 if [ $? -ne 0 ]; then
277 if [ -z "$4" ]; then
278 echo
279 echo " $2 not found at $1 or $3 headers not found"
280 echo " Check the file $LOG for detailed error information."
281 fail
282 else
283 echo >> $LOG
284 echo >> $LOG
285 fi
286 return 1
287 fi
288 return 0
289}
290
291
292# Execute a compiled test binary
293test_execute()
294{
295 echo "executing the binary" >> $LOG
296 $ODIR.tmp_out > $ODIR.test_execute.log
297 rc=$?
298 cat $ODIR.test_execute.log | tee -a $LOG
299 if [ $rc -ne 0 ]; then
300 fail $1
301 return 1
302 fi
303 echo >> $LOG
304 echo >> $LOG
305 return 0
306}
307
308
309# Execute a compiled test binary
310test_execute_path()
311{
312 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
313 LD_LIBRARY_PATH=$1 $ODIR.tmp_out > $ODIR.test_execute.log
314 rc=$?
315 cat $ODIR.test_execute.log | tee -a $LOG
316 if [ $rc -ne 0 ]; then
317 fail
318 return 1
319 fi
320 echo >> $LOG
321 echo >> $LOG
322 return 0
323}
324
325
326#
327# Check for OS, MACHINE, CPU
328#
329check_environment()
330{
331 test_header environment
332 BUILD_CPU=`uname -m`
333 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
334 case "$BUILD_CPU" in
335 i[3456789]86|x86|i86pc)
336 BUILD_MACHINE='x86'
337 LIB='lib'
338 ;;
339 x86_64|amd64)
340 BUILD_MACHINE='amd64'
341 BUILD_CPU='k8'
342 if [ "$OS" != "solaris" ]; then
343 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
344 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
345 LIB='lib64'
346 else
347 # Solaris doesn't seem to subscribe to fhs, libs are usually in
348 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
349 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
350 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
351 # have to make sure the */bin/amd64 dirs are searched before the */bin
352 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
353 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
354 echo "old PATH: $PATH" >> $LOG
355 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
356 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
357 export PATH
358 echo "new PATH: $PATH" >> $LOG
359 LIB='lib/64'
360 fi
361 ;;
362 *)
363 log_failure "Cannot determine system"
364 exit 1
365 ;;
366 esac
367 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
368 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
369 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
370 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
371
372 echo "BUILD_PLATFORM=\"$OS\"" >> $ENV
373 echo "export BUILD_PLATFORM" >> $ENV
374 echo "BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
375 echo "export BUILD_PLATFORM_ARCH" >> $ENV
376 echo "BUILD_TARGET=\"$OS\"" >> $ENV
377 echo "export BUILD_TARGET" >> $ENV
378 echo "BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
379 echo "export BUILD_TARGET_ARCH" >> $ENV
380 echo "BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
381 echo "export BUILD_TARGET_CPU" >> $ENV
382 echo "BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
383 echo "export BUILD_TYPE" >> $ENV
384}
385
386#
387# Check for gcc with version >= 3.2.
388# We depend on a working gcc, if we fail terminate in every case.
389#
390check_gcc()
391{
392 test_header gcc
393 if check_avail "$CC" CC really; then
394 cc_ver=`$CC -dumpversion` 2>/dev/null
395 if [ $? -ne 0 ]; then
396 log_failure "cannot execute '$CC -dumpversion'"
397 fail really
398 fi
399 if check_avail "$CXX" CXX really; then
400 cxx_ver=`$CXX -dumpversion` 2>/dev/null
401 if [ $? -ne 0 ]; then
402 log_failure "cannot execute '$CXX -dumpversion'"
403 fail really
404 fi
405 cc_maj=`echo $cc_ver|cut -d. -f1`
406 cc_min=`echo $cc_ver|cut -d. -f2`
407 if [ "x$cc_ver" != "x$cxx_ver" ]; then
408 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
409 fail really
410 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "$OS" = "darwin" ]; then
411 log_success "found version $cc_ver"
412 # gcc-4.0 is allowed for Darwin only
413 elif [ $cc_maj -lt 3 \
414 -o \( $cc_maj -eq 3 -a $cc_min -lt 2 \) \
415 -o \( $cc_maj -eq 4 -a $cc_min -lt 1 -a "$OS" != "darwin" \) \
416 -o \( $cc_maj -eq 4 -a $cc_min -gt 7 \) \
417 -o $cc_maj -gt 4 ]; then
418 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with 0<x<8"
419 fail really
420 else
421 log_success "found version $cc_ver"
422 fi
423 if [ "$BUILD_MACHINE" = "amd64" ]; then
424 [ -z "$CC32" ] && CC32="$CC -m32"
425 [ -z "$CXX32" ] && CXX32="$CXX -m32"
426 else
427 [ -z "$CC32" ] && CC32="$CC"
428 [ -z "$CXX32" ] && CXX32="$CXX"
429 fi
430 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
431 [ -z "$CC64" ] && CC64="$CC -m64"
432 [ -z "$CXX64" ] && CXX64="$CXX -m64"
433 fi
434 if [ "$TARGET_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 0 ]; then
435 CC32="undefined"
436 CXX32="undefined"
437 fi
438 if [ "$CC" != "gcc" ]; then
439 cnf_append "TOOL_GCC3_CC" "$CC"
440 cnf_append "TOOL_GCC3_AS" "$CC"
441 cnf_append "TOOL_GCC3_LD" "$CC"
442 cnf_append "TOOL_GXX3_CC" "$CC"
443 cnf_append "TOOL_GXX3_AS" "$CC"
444 fi
445 if [ "$CXX" != "g++" ]; then
446 cnf_append "TOOL_GCC3_CXX" "$CXX"
447 cnf_append "TOOL_GXX3_CXX" "$CXX"
448 cnf_append "TOOL_GXX3_LD" "$CXX"
449 fi
450 if [ "$CC32" != "gcc -m32" -a "$CC32" != "undefined" ]; then
451 cnf_append "TOOL_GCC32_CC" "$CC32"
452 cnf_append "TOOL_GCC32_AS" "$CC32"
453 cnf_append "TOOL_GCC32_LD" "$CC32"
454 cnf_append "TOOL_GXX32_CC" "$CC32"
455 cnf_append "TOOL_GXX32_AS" "$CC32"
456 fi
457 if [ "$CXX32" != "g++ -m32" -a "$CXX32" != "undefined" ]; then
458 cnf_append "TOOL_GCC32_CXX" "$CXX32"
459 cnf_append "TOOL_GXX32_CXX" "$CXX32"
460 cnf_append "TOOL_GXX32_LD" "$CXX32"
461 fi
462 # this isn't not necessary, there is not such tool.
463 if [ -n "$CC64" ]; then
464 cnf_append "TOOL_GCC64_CC" "$CC64"
465 cnf_append "TOOL_GCC64_AS" "$CC64"
466 cnf_append "TOOL_GCC64_LD" "$CC64"
467 cnf_append "TOOL_GXX64_CC" "$CC64"
468 cnf_append "TOOL_GXX64_AS" "$CC64"
469 fi
470 if [ -n "$CXX64" ]; then
471 cnf_append "TOOL_GCC64_CXX" "$CXX64"
472 cnf_append "TOOL_GXX64_CXX" "$CXX64"
473 cnf_append "TOOL_GXX64_LD" "$CXX64"
474 fi
475 # Solaris sports a 32-bit gcc/g++.
476 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
477 [ "$CC" = "gcc" ] && CC="gcc -m64"
478 [ "$CXX" = "g++" ] && CXX="g++ -m64"
479 fi
480 fi
481 fi
482}
483
484
485#
486# Check for the bcc compiler, needed for compiling the BIOS
487#
488check_bcc()
489{
490 test_header bcc
491 if check_avail "$BCC" BCC; then
492 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
493 if [ $? -ne 0 ]; then
494 log_failure "BCC not found"
495 fail
496 else
497 echo "compiling the following source file:" >> $LOG
498 cat > $ODIR.tmp_src.c << EOF
499int foo(a)
500 int a;
501{
502 return 0;
503}
504EOF
505 cat $ODIR.tmp_src.c >> $LOG
506 bcc_path=`which_wrapper $BCC`
507 bcc_dir="`dirname $bcc_path`/"
508 echo "using the following command line:" >> $LOG
509 echo "$BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
510 $BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
511 if [ $? -ne 0 ]; then
512 log_failure "BCC not working"
513 fail
514 else
515 log_success "found version $bcc_ver"
516 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
517 fi
518 unset bcc_path
519 unset bcc_dir
520 fi
521 fi
522}
523
524
525#
526# Check for the as86 assembler, needed for compiling the BIOS
527#
528check_as86()
529{
530 test_header as86
531 if check_avail "$AS86" AS86; then
532 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
533 if [ $? -ne 0 ]; then
534 log_failure "as86 not found"
535 fail
536 else
537 log_success "found version $as86_ver"
538 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
539 fi
540 fi
541}
542
543
544#
545# Check for the OpenWatcom compiler, needed for compiling the BIOS
546#
547# If the system has Open Watcom installed, WATCOM will be set in the
548# environment. If the user has her/his own Open Watcom install it will be
549# pointed to by on the command line, which will set the WATCOM variable.
550# The only exception is detecting OpenWatcom in tools/common/openwatcom.
551#
552check_open_watcom()
553{
554 test_header "Open Watcom"
555
556 if [ -z "$WATCOM" ]; then
557 WATCOM=`/bin/ls -rd1 $PWD/tools/common/openwatcom/* 2> /dev/null | head -1`
558 if [ -z "$WATCOM" ]; then
559 log_failure "Open Watcom was not found"
560 cnf_append "VBOX_WITH_OPEN_WATCOM" ""
561 return 0;
562 fi
563 fi
564
565 case "$OS" in
566 "darwin") wc_bin="binosx";; # ??
567 "dos") wc_bin="binw";;
568 "freebsd") wc_bin="binfbsd";; # ??
569 "linux") wc_bin="binl";;
570 "solaris") wc_bin="binsol";; # ??
571 "os2") wc_bin="binp";;
572 "win") wc_bin="binnt";;
573 *) wc_bin="binl";;
574 esac
575
576 # Check that the tools we use are there.
577 for prog in wasm wcc wlink;
578 do
579 if [ ! -f "$WATCOM/$wc_bin/$prog" ]; then
580 log_failure "$WATCOM/$wc_bin/$prog does not exist or is not a regular file."
581 fail
582 fi
583 done
584
585 # Use WASM to get the version.
586 wasm_ver=`$WATCOM/$wc_bin/wasm -? 2>&1 | sed -e '1!d' -e 's/Open Watcom Assembler Version *//'`
587 if [ -z "$wasm_ver" ]; then
588 log_failure "$WATCOM/$wc_bin/wasm -? did not produce the expected response"
589 fail
590 fi
591 log_success "found version $wasm_ver"
592 cnf_append "PATH_TOOL_OPENWATCOM" "$WATCOM"
593 cnf_append "VBOX_WITH_OPEN_WATCOM" "1"
594
595 unset wasm_ver
596 unset wc_wasm
597 unset wc_bin
598}
599
600
601#
602# Check for yasm, needed to compile assembler files
603#
604check_yasm()
605{
606 test_header yasm
607 if check_avail "$YASM" YASM; then
608 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
609 if [ $? -ne 0 ]; then
610 log_failure "yasm not found"
611 fail
612 else
613 yasm_maj=`echo $yasm_ver|cut -d. -f1`
614 yasm_min=`echo $yasm_ver|cut -d. -f2`
615 yasm_rev=`echo $yasm_ver|cut -d. -f3`
616 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
617 if [ $yasm_ver_mul -lt 501 ]; then
618 log_failure "found version $yasm_ver, expected at least 0.5.1"
619 fail
620 else
621 log_success "found version $yasm_ver"
622 fi
623 fi
624 fi
625}
626
627
628#
629# Check for the iasl ACPI compiler, needed to compile vbox.dsl
630#
631check_iasl()
632{
633 test_header iasl
634 if check_avail "$IASL" IASL; then
635 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
636 if [ $? -ne 0 ]; then
637 log_failure "iasl not found"
638 fail
639 else
640 log_success "found version $iasl_ver"
641 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
642 fi
643 fi
644}
645
646
647#
648# Check for xsltproc, needed by Main
649#
650check_xsltproc()
651{
652 test_header xslt
653 if check_avail "$XSLTPROC" XSLTPROC; then
654 xsltproc_ver=`$XSLTPROC --version`
655 if [ $? -ne 0 ]; then
656 log_failure "xsltproc not found"
657 fail
658 else
659 log_success "found"
660 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
661 fi
662 fi
663}
664
665
666#
667# Check for mkisofs, needed to build the CDROM image containing the additions
668#
669check_mkisofs()
670{
671 test_header mkisofs
672 if which_wrapper $GENISOIMAGE > /dev/null; then
673 mkisofs_ver=`$GENISOIMAGE --version`
674 if [ $? -ne 0 ]; then
675 log_failure "mkisofs not found"
676 fail
677 else
678 log_success "found $mkisofs_ver"
679 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
680 fi
681 elif check_avail "$MKISOFS" MKISOFS; then
682 mkisofs_ver=`$MKISOFS --version`
683 if [ $? -ne 0 ]; then
684 log_failure "mkisofs not working"
685 fail
686 else
687 log_success "found $mkisofs_ver"
688 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
689 fi
690 fi
691}
692
693
694#
695# Check for libxml2, needed by VBoxSettings and Runtime.
696# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
697#
698check_libxml2()
699{
700 if [ -z "$BUILD_LIBXML2" ]; then
701 test_header libxml2
702 if which_wrapper pkg-config > /dev/null; then
703 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
704 if [ $? -ne 0 ]; then
705 log_failure "libxml2 not found"
706 fail
707 else
708 FLGXML2=`pkg-config libxml-2.0 --cflags`
709 INCXML2=`strip_I "$FLGXML2"`
710 LIBXML2=`pkg-config libxml-2.0 --libs`
711 cat > $ODIR.tmp_src.cc << EOF
712#include <cstdio>
713#include <libxml/xmlversion.h>
714extern "C" int main(void)
715{
716 printf("found version %s", LIBXML_DOTTED_VERSION);
717#if LIBXML_VERSION >= 20626
718 printf(", OK.\n");
719 return 0;
720#else
721 printf(", expected version 2.6.26 or higher\n");
722 return 1;
723#endif
724}
725EOF
726 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
727 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
728 if test_execute; then
729 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
730 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
731 fi
732 fi
733 fi
734 elif which_wrapper xml2-config; then
735 libxml2_ver=`xml2-config --version`
736 if [ $? -ne 0 ]; then
737 log_failure "xml2-config not found"
738 fail
739 else
740 log_success "found version $libxml2_ver"
741 FLGXML2=`xml2-config --cflags`
742 INCXML2=`strip_I "$FLGXML2"`
743 LIBXML2=`xml2-config --libs`
744 cat > $ODIR.tmp_src.cc << EOF
745#include <cstdio>
746#include <libxml/xmlversion.h>
747extern "C" int main(void)
748{
749 printf("found version %s", LIBXML_DOTTED_VERSION);
750#if LIBXML_VERSION >= 20626
751 printf(", OK.\n");
752 return 0;
753#else
754 printf(", expected version 2.6.26 or higher\n");
755 return 1;
756#endif
757}
758EOF
759 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
760 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
761 if test_execute; then
762 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
763 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
764 fi
765 fi
766 fi
767 else
768 log_failure "neither pkg-config nor xml2-config found"
769 fail
770 fi
771 fi
772}
773
774
775#
776# Check for libIDL, needed by xpcom
777#
778check_libidl()
779{
780 test_header libIDL
781
782 if which_wrapper libIDL-config-2 > /dev/null; then
783 libidl_ver=`libIDL-config-2 --version`
784 if [ $? -ne 0 ]; then
785 log_failure "libIDL-config-2 not working"
786 fail
787 else
788 log_success "found version $libidl_ver"
789 cnf_append "VBOX_LIBIDL_CONFIG" \
790 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
791 fi
792 elif check_avail "libIDL-config" libIDL-config; then
793 libidl_ver=`libIDL-config --version`
794 if [ $? -ne 0 ]; then
795 log_failure "libIDL-config not working"
796 fail
797 else
798 log_success "found version $libidl_ver"
799 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
800 fi
801 fi
802}
803
804
805#
806# Check for openssl, needed for RDP and S3
807#
808check_ssl()
809{
810 if [ -z "$BUILD_LIBSSL" ]; then
811 test_header ssl
812 cat > $ODIR.tmp_src.cc << EOF
813#include <cstdio>
814#include <openssl/opensslv.h>
815#include <openssl/ssl.h>
816extern "C" int main(void)
817{
818 printf("found version %s", OPENSSL_VERSION_TEXT);
819 SSL_library_init();
820#if OPENSSL_VERSION_NUMBER >= 0x00908000
821 printf(", OK.\n");
822 return 0;
823#else
824 printf(", expected version 0.9.8 or higher\n");
825 return 1;
826#endif
827}
828EOF
829 if test_compile "$INCCRYPTO $LIBCRYPTO" libcrypto openssl; then
830 if test_execute nofatal; then
831 cnf_append "SDK_VBOX_OPENSSL_INCS" "`strip_I "$INCCRYPTO"`"
832 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
833 cnf_append "SDK_VBOX_BLD_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
834 fi
835 fi
836 fi
837}
838
839
840#
841# Check for pthread, needed by VBoxSVC, frontends, ...
842#
843check_pthread()
844{
845 test_header pthread
846 cat > $ODIR.tmp_src.cc << EOF
847#include <cstdio>
848#include <pthread.h>
849extern "C" int main(void)
850{
851 pthread_mutex_t mutex;
852 if (pthread_mutex_init(&mutex, NULL)) {
853 printf("pthread_mutex_init() failed\n");
854 return 1;
855 }
856 if (pthread_mutex_lock(&mutex)) {
857 printf("pthread_mutex_lock() failed\n");
858 return 1;
859 }
860 if (pthread_mutex_unlock(&mutex)) {
861 printf("pthread_mutex_unlock() failed\n");
862 return 1;
863 }
864 printf("found, OK.\n");
865}
866EOF
867 if test_compile $LIBPTHREAD pthread pthread; then
868 if test_execute; then
869 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
870 fi
871 fi
872}
873
874
875#
876# Check for zlib, needed by VBoxSVC, Runtime, ...
877#
878check_z()
879{
880 test_header zlib
881 cat > $ODIR.tmp_src.cc << EOF
882#include <cstdio>
883#include <zlib.h>
884extern "C" int main(void)
885{
886 printf("found version %s", ZLIB_VERSION);
887#if ZLIB_VERNUM >= 0x1210
888 printf(", OK.\n");
889 return 0;
890#else
891 printf(", expected version 1.2.1 or higher\n");
892 return 1;
893#endif
894}
895EOF
896 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
897 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
898 if test_execute; then
899 echo "if1of (\$(KBUILD_TARGET),darwin freebsd linux solaris)" >> $CNF
900 cnf_append " SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
901 cnf_append " SDK_VBOX_ZLIB_INCS" "$INCZ"
902 echo "endif" >> $CNF
903 fi
904 fi
905}
906
907
908#
909# Check for libpng, needed by kchmviewer
910#
911check_png()
912{
913 test_header libpng
914 cat > $ODIR.tmp_src.cc << EOF
915#include <cstdio>
916#include <png.h>
917extern "C" int main(void)
918{
919 printf("found version %s", PNG_LIBPNG_VER_STRING);
920#if PNG_LIBPNG_VER >= 10205
921 printf(", OK.\n");
922 return 0;
923#else
924 printf(", expected version 1.2.5 or higher\n");
925 return 1;
926#endif
927}
928EOF
929 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
930 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
931 if test_execute; then
932 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
933 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
934 fi
935 fi
936}
937
938#
939# Check for libvncserver, needed for VNC in OSE
940#
941check_vncserver()
942{
943 test_header libvncserver
944 cat > $ODIR.tmp_src.cc <<EOF
945#include <cstdio>
946#include <rfb/rfbconfig.h>
947
948extern "C" int main()
949{
950 const char* v=LIBVNCSERVER_VERSION;
951 unsigned int major = 0, minor = 0, micro = 0;
952
953 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
954 if (*v == '.') v++;
955 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
956 if (*v == '.') v++;
957 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
958
959 printf("found version %s", LIBVNCSERVER_PACKAGE_VERSION);
960 if (major*10000 + minor*100 + micro >= 900)
961 {
962 printf(", OK.\n");
963 return 0;
964 }
965 else
966 {
967 printf(", expected version 0.9 or higher\n");
968 return 1;
969 }
970}
971EOF
972 if test_compile "$LIBVNCSERVER $INCVNCSERVER" libvncserver libvncserver; then
973 if test_execute; then
974 cnf_append "VBOX_WITH_EXTPACK_VNC" "1"
975 fi
976 fi
977}
978
979#
980# Check for libcurl, needed by S3
981#
982check_curl()
983{
984 if [ -z "$BUILD_LIBCURL" ]; then
985 test_header libcurl
986 cat > $ODIR.tmp_src.cc << EOF
987#include <cstdio>
988#include <curl/curl.h>
989extern "C" int main(void)
990{
991 printf("found version %s", LIBCURL_VERSION);
992#if 10000*LIBCURL_VERSION_MAJOR + 100*LIBCURL_VERSION_MINOR + LIBCURL_VERSION_PATCH >= 71601
993 printf(", OK.\n");
994 return 0;
995#else
996 printf(", expected version 7.16.1 or higher\n");
997 return 1;
998#endif
999}
1000EOF
1001 [ -n "$INCCURL" ] && I_INCCURL=`prefix_I "$INCCURL"`
1002 if test_compile "$LIBCURL $I_INCCURL" libcurl libcurl; then
1003 if test_execute; then
1004 cnf_append "SDK_VBOX_LIBCURL_LIBS" "`strip_l "$LIBCURL"`"
1005 cnf_append "SDK_VBOX_LIBCURL_INCS" "$INCCURL"
1006 fi
1007 fi
1008 fi
1009}
1010
1011
1012#
1013# Check for pam, needed by VRDPAuth
1014# Version 79 was introduced in 9/2005, do we support older versions?
1015# Debian/sarge uses 76
1016# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
1017#
1018check_pam()
1019{
1020 test_header pam
1021 cat > $ODIR.tmp_src.cc << EOF
1022#include <cstdio>
1023#include <security/pam_appl.h>
1024extern "C" int main(void)
1025{
1026 printf("found version %d", __LIBPAM_VERSION);
1027 if (__LIBPAM_VERSION >= 76)
1028 {
1029 printf(", OK.\n");
1030 return 0;
1031 }
1032 else
1033 {
1034 printf(", expected version 76 or higher\n");
1035 return 1;
1036 }
1037}
1038EOF
1039 if test_compile "-lpam" pam pam nofatal; then
1040 if test_execute nofatal; then
1041 return 0;
1042 fi
1043 fi
1044 echo "pam0.x not found"
1045 test_header linux_pam
1046 cat > $ODIR.tmp_src.cc << EOF
1047#include <cstdio>
1048#include <security/pam_appl.h>
1049extern "C" int main(void)
1050{
1051 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
1052 if (__LINUX_PAM__ >= 1)
1053 {
1054 printf(", OK.\n");
1055 return 0;
1056 }
1057 else
1058 {
1059 printf(", expected version 1.0 or higher\n");
1060 return 1;
1061 }
1062}
1063EOF
1064 if test_compile "-lpam" pam pam; then
1065 test_execute
1066 fi
1067}
1068
1069
1070#
1071# Check for the SDL library, needed by VBoxSDL and VirtualBox
1072# We depend at least on version 1.2.7
1073#
1074check_sdl()
1075{
1076 test_header SDL
1077 if [ "$OS" = "darwin" ]; then
1078 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1079 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
1080 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1081 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1082 fi
1083 if [ -n "$PATH_SDK_LIBSDL" ]; then
1084 foundsdl=1
1085 INCSDL="$PATH_SDK_LIBSDL/Headers"
1086 FLDSDL="-framework SDL"
1087 else
1088 log_failure "SDL framework not found"
1089 fail
1090 fi
1091 else
1092 if which_wrapper sdl-config > /dev/null; then
1093 FLGSDL=`sdl-config --cflags`
1094 INCSDL=`strip_I "$FLGSDL"`
1095 LIBSDL=`sdl-config --libs`
1096 LIBSDLMAIN="-lSDLmain"
1097 FLDSDL=
1098 foundsdl=1
1099 fi
1100 fi
1101 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1102 if [ -n "$foundsdl" ]; then
1103 cat > $ODIR.tmp_src.cc << EOF
1104#include <cstdio>
1105#include <SDL.h>
1106#include <SDL_main.h>
1107#undef main
1108extern "C" int main(int argc, char** argv)
1109{
1110 printf("found version %d.%d.%d",
1111 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1112#if SDL_VERSION_ATLEAST(1,2,7)
1113 printf(", OK.\n");
1114 return 0;
1115#else
1116 printf(", expected version 1.2.7 or higher\n");
1117 return 1;
1118#endif
1119}
1120EOF
1121 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1122 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1123 if test_execute; then
1124 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1125 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1126 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1127 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1128 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1129 fi
1130 fi
1131 else
1132 log_failure "SDL not found"
1133 fail
1134 fi
1135}
1136
1137
1138#
1139# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1140#
1141check_sdl_ttf()
1142{
1143 test_header SDL_ttf
1144 cat > $ODIR.tmp_src.cc << EOF
1145#include <cstdio>
1146#include <SDL_ttf.h>
1147#ifndef SDL_TTF_MAJOR_VERSION
1148#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1149#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1150#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1151#endif
1152extern "C" int main(void)
1153{
1154 printf("found version %d.%d.%d",
1155 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1156#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1157 printf(", OK.\n");
1158 return 0;
1159#else
1160 printf(", expected version 2.0.6 or higher\n");
1161 return 1;
1162#endif
1163}
1164EOF
1165 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1166 if ! test_execute nofatal; then
1167 cnf_append "VBOX_WITH_SECURELABEL" ""
1168 fi
1169 else
1170 echo "not found -- disabling VBoxSDL secure label."
1171 cnf_append "VBOX_WITH_SECURELABEL" ""
1172 fi
1173}
1174
1175
1176#
1177# Check for libasound, needed by the ALSA audio backend
1178#
1179check_alsa()
1180{
1181 test_header ALSA
1182 cat > $ODIR.tmp_src.cc << EOF
1183#include <cstdio>
1184#include <alsa/asoundlib.h>
1185extern "C" int main(void)
1186{
1187 printf("found version %d.%d.%d",
1188 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1189#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1190 printf(", OK.\n");
1191 return 0;
1192#else
1193 printf(", expected version 1.0.6 or higher\n");
1194 return 1;
1195#endif
1196}
1197EOF
1198 if test_compile "-lasound" asound asound; then
1199 test_execute
1200 fi
1201}
1202
1203
1204#
1205# Check for PulseAudio
1206#
1207check_pulse()
1208{
1209 test_header "PulseAudio"
1210 cat > $ODIR.tmp_src.cc << EOF
1211#include <cstdio>
1212#include <pulse/version.h>
1213extern "C" int main(void)
1214{
1215 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1216#if PA_API_VERSION >= 9
1217 printf(", OK.\n");
1218 return 0;
1219#else
1220 printf(", expected version 0.9.0 (API version 9) or higher\n");
1221 return 1;
1222#endif
1223}
1224EOF
1225 if test_compile "$INCPULSE $LIBPULSE -lpulse" pulse pulse; then
1226 test_execute
1227 fi
1228}
1229
1230
1231#
1232# Check for the X libraries (Xext, X11)
1233#
1234check_x()
1235{
1236 test_header "X libraries"
1237 cat > $ODIR.tmp_src.cc << EOF
1238#include <cstdio>
1239#include <X11/Xlib.h>
1240extern "C" int main(void)
1241{
1242 Display *dpy;
1243 int scrn_num;
1244 Screen *scrn;
1245 Window win;
1246
1247 dpy = XOpenDisplay(NULL);
1248 scrn_num = DefaultScreen(dpy);
1249 scrn = ScreenOfDisplay(dpy, scrn_num);
1250 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1251 0, 16, InputOutput, CopyFromParent, 0, NULL);
1252 XDestroyWindow(dpy, win);
1253 XCloseDisplay(dpy);
1254}
1255EOF
1256 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1257 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1258 log_success "found"
1259 fi
1260}
1261
1262
1263#
1264# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
1265#
1266check_xcursor()
1267{
1268 test_header Xcursor
1269 cat > $ODIR.tmp_src.cc << EOF
1270#include <cstdio>
1271#include <X11/Xlib.h>
1272#include <X11/Xcursor/Xcursor.h>
1273extern "C" int main(void)
1274{
1275 XcursorImage *cursor = XcursorImageCreate (10, 10);
1276 XcursorImageDestroy(cursor);
1277 return 0;
1278}
1279EOF
1280 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1281 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1282 log_success "found"
1283 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1284 fi
1285}
1286
1287
1288#
1289# Check for the Xinerama library, needed by the Qt GUI
1290#
1291check_xinerama()
1292{
1293 test_header Xinerama
1294 cat > $ODIR.tmp_src.cc << EOF
1295#include <X11/Xlib.h>
1296#include <X11/extensions/Xinerama.h>
1297extern "C" int main(void)
1298{
1299 Display *dpy;
1300 Bool flag;
1301 dpy = XOpenDisplay(NULL);
1302 if (dpy)
1303 {
1304 flag = XineramaIsActive(dpy);
1305 XCloseDisplay(dpy);
1306 }
1307}
1308EOF
1309 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1310 if test_compile "$LIBX11 $LIBXINERAMA $I_INCX11" Xinerama Xinerama; then
1311 log_success "found"
1312 fi
1313}
1314
1315
1316#
1317# Check for the Xinerama library, needed by the Qt GUI
1318#
1319check_xrandr()
1320{
1321 test_header Xrandr
1322 cat > $ODIR.tmp_src.cc << EOF
1323#include <X11/Xlib.h>
1324#include <X11/extensions/Xrandr.h>
1325extern "C" int main(void)
1326{
1327 Display *dpy;
1328 Bool flag;
1329 int major, minor;
1330 dpy = XOpenDisplay(NULL);
1331 if (dpy)
1332 {
1333 flag = XRRQueryVersion(dpy, &major, &minor);
1334 XCloseDisplay(dpy);
1335 }
1336}
1337EOF
1338 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1339 if test_compile "$LIBX11 $LIBXRANDR $I_INCX11" Xrandr Xrandr; then
1340 log_success "found"
1341 fi
1342}
1343
1344
1345#
1346# Check for OpenGL
1347#
1348check_opengl()
1349{
1350 # On darwin this is a on/off decision only
1351 if [ "$OS" = "darwin" ]; then
1352 test_header "OpenGL support"
1353 echo "enabled"
1354 cnf_append "VBOX_WITH_CROGL" "1"
1355 else
1356 check_xmu
1357 check_mesa
1358 fi
1359}
1360
1361
1362#
1363# Check for the Xmu library, needed by OpenGL
1364#
1365check_xmu()
1366{
1367 test_header Xmu
1368 cat > $ODIR.tmp_src.cc << EOF
1369#include <cstdio>
1370#include <X11/Xatom.h>
1371#include <X11/Xlib.h>
1372#include <X11/Xutil.h>
1373#include <X11/Xmu/StdCmap.h>
1374extern "C" int main(void)
1375{
1376 Display *dpy;
1377 int scrn_num;
1378 Screen *scrn;
1379
1380 dpy = XOpenDisplay(NULL);
1381 if (dpy)
1382 {
1383 scrn_num = DefaultScreen(dpy);
1384 scrn = ScreenOfDisplay(dpy, scrn_num);
1385 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1386 24, XA_RGB_DEFAULT_MAP, False, True);
1387 printf("Status = %x\n", status);
1388 XCloseDisplay(dpy);
1389 }
1390 return 0;
1391}
1392EOF
1393 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1394 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1395 log_success "found"
1396 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1397 fi
1398}
1399
1400#
1401# Check for Mesa, needed by OpenGL
1402#
1403check_mesa()
1404{
1405 test_header "Mesa / GLU"
1406 cat > $ODIR.tmp_src.cc << EOF
1407#include <cstdio>
1408#include <X11/Xlib.h>
1409#include <GL/glx.h>
1410#include <GL/glu.h>
1411extern "C" int main(void)
1412{
1413 Display *dpy;
1414 int major, minor;
1415
1416 dpy = XOpenDisplay(NULL);
1417 if (dpy)
1418 {
1419 Bool glx_version = glXQueryVersion(dpy, &major, &minor);
1420 XCloseDisplay(dpy);
1421 if (glx_version)
1422 {
1423 printf("found version %u.%u, OK.\n", major, minor);
1424 return 0;
1425 }
1426 }
1427 printf("found (inactive), OK.\n");
1428 return 0;
1429}
1430EOF
1431 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1432 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1433 [ $PASSIVE_MESA -eq 1 ] && unset DISPLAY
1434 test_execute
1435 fi
1436}
1437
1438
1439#
1440# Check for the Qt4 library, needed by the VirtualBox frontend
1441#
1442# Currently not fatal.
1443#
1444check_qt4()
1445{
1446 foundqt4=
1447 test_header Qt4
1448 if [ "$OS" = "darwin" ]; then
1449 # First check if there is the internal version of Qt. If yes nothing else
1450 # has to be done.
1451 QT_INTERNAL=`/bin/ls -rd1 $PWD/tools/$BUILD_TARGET.$BUILD_PLATFORM_ARCH/qt/* 2> /dev/null`
1452 for t in $QT_INTERNAL; do
1453 if [ -f "$t/Frameworks/QtCoreVBox.framework/QtCoreVBox" ]; then
1454 cnf_append "VBOX_WITH_QT4_SUN" "1"
1455 log_success "use internal version"
1456 return
1457 fi
1458 done
1459 # Now try the user provided directory and some of the standard directories.
1460 QT_TRIES="$QT4DIR /System/Library /Library"
1461 for t in $QT_TRIES; do
1462 if [ -f "$t/Frameworks/QtCore.framework/QtCore" ]; then
1463 PATH_SDK_QT4="$t"
1464 break
1465 fi
1466 done
1467 # Add the necessary params for building the test application
1468 if [ -n "$PATH_SDK_QT4" ]; then
1469 foundqt4=1
1470 INCQT4=-I$PATH_SDK_QT4/Frameworks/QtCore.framework/Headers
1471 LIBQT4=-F$PATH_SDK_QT4/Frameworks
1472 FLGQT4="-framework QtCore"
1473 else
1474 log_failure "Qt4 framework not found (can be disabled using --disable-qt4)"
1475 fail
1476 fi
1477 else
1478 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1479 # default is to use pkg-config
1480 if which_wrapper pkg-config > /dev/null; then
1481 # this braindead path is necessary for mdv2008.1
1482 qt4_ver=`\
1483 PKG_CONFIG_PATH=$PKG_CONFIG_PATH:/usr/lib/qt4/lib/pkgconfig \
1484 pkg-config QtCore --modversion 2>> $LOG`
1485 if [ $? -ne 0 ]; then
1486 log_failure "QtCore not found"
1487 fail
1488 else
1489 FLGQT4=`\
1490 PKG_CONFIG_PATH=$PKG_CONFIG_PATH:/usr/lib/qt4/lib/pkgconfig \
1491 pkg-config QtCore --cflags`
1492 INCQT4=`strip_I "$FLGQT4"`
1493 LIBQT4=`\
1494 PKG_CONFIG_PATH=$PKG_CONFIG_PATH:/usr/lib/qt4/lib/pkgconfig \
1495 PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 \
1496 pkg-config QtCore --libs`
1497 foundqt4=1
1498 fi
1499 else
1500 log_failure "pkg-config not found"
1501 fail
1502 fi
1503 else
1504 # do it the old way (e.g. user has specified QT4DIR)
1505 cat > $ODIR.tmp_src.cc << EOF
1506#include <cstdio>
1507#include <QtGlobal>
1508extern "C" int main(void)
1509{
1510 printf("found version %s", QT_VERSION_STR);
1511#if QT_VERSION >= 0x040602
1512 printf(", OK.\n");
1513 return 0;
1514#else
1515 printf(", expected version 4.6.2 or higher\n");
1516 return 1;
1517#endif
1518}
1519EOF
1520 for q in $QT4DIR; do
1521 INCQT4="$q/include $q/include/QtCore"
1522 FLGQT4="-DQT_SHARED"
1523 I_INCQT4=`prefix_I "$INCQT4"`
1524 LIBQT4="-L$q/lib -lQtCoreVBox"
1525 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1526 foundqt4=2
1527 break;
1528 fi
1529 LIBQT4="-L$q/lib -lQtCore"
1530 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1531 foundqt4=1
1532 break;
1533 fi
1534 done
1535 fi
1536 fi
1537 if [ -n "$foundqt4" ]; then
1538 cat > $ODIR.tmp_src.cc << EOF
1539#include <cstdio>
1540#include <QtGlobal>
1541extern "C" int main(void)
1542{
1543 printf("found version %s", QT_VERSION_STR);
1544#if QT_VERSION >= 0x040602
1545 printf(", OK.\n");
1546 return 0;
1547#else
1548 printf(", expected version 4.6.2 or higher\n");
1549 return 1;
1550#endif
1551}
1552EOF
1553 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1554 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1555 if test_execute_path "`strip_L "$LIBQT4"`"; then
1556 if [ "$OS" = "darwin" ]; then
1557 # Successful build & run the test application so add the necessary
1558 # params to AutoConfig.kmk
1559 cnf_append "PATH_SDK_QT4_INC" "$PATH_SDK_QT4/Frameworks"
1560 cnf_append "PATH_SDK_QT4_LIB" "$PATH_SDK_QT4/Frameworks"
1561 cnf_append "PATH_SDK_QT4" "$PATH_SDK_QT4/Frameworks"
1562 # Check for the moc tool in the Qt directory found & some standard
1563 # directories.
1564 for q in $PATH_SDK_QT4 /usr /Developer/Tools/Qt; do
1565 if which_wrapper "$q/bin/moc" > /dev/null; then
1566 cnf_append "PATH_TOOL_QT4" "$q"
1567 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1568 fi
1569 done
1570 else
1571 # strip .../QtCore as we add components ourself
1572 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1573 # store only the first path, remove all other pathes
1574 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1575 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1576 cnf_append "VBOX_PATH_QT4_LIB" "`strip_L "$LIBQT4"`"
1577 cnf_append "SDK_QT4_LIBPATH" "`strip_L "$LIBQT4"`"
1578 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1579 # this is not quite right since the qt libpath does not have to be first...
1580 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1581 if [ "$foundqt4" = "2" ]; then
1582 cnf_append "VBOX_WITH_QT4_SUN" "1"
1583 fi
1584 test_header "Qt4 devtools"
1585 for q in $QT4DIR; do
1586 # first try it with a suffix, some platforms use that
1587 if which_wrapper "$q/bin/moc-qt4" > /dev/null; then
1588 moc_ver=`$q/bin/moc-qt4 -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1589 if [ $? -ne 0 ]; then
1590 log_failure "moc-qt4 not working"
1591 fail
1592 else
1593 log_success "found version $moc_ver"
1594 cnf_append "VBOX_PATH_QT4" "$q"
1595 cnf_append "PATH_SDK_QT4" "$q"
1596 cnf_append "PATH_TOOL_QT4" "$q"
1597 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1598 cnf_append "TOOL_QT4_BIN_SUFF" "-qt4"
1599 return
1600 fi
1601 elif which_wrapper "$q/bin/moc" > /dev/null; then
1602 moc_ver=`$q/bin/moc -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1603 if [ $? -ne 0 ]; then
1604 log_failure "moc not working"
1605 fail
1606 else
1607 log_success "found version $moc_ver"
1608 cnf_append "VBOX_PATH_QT4" "$q"
1609 cnf_append "PATH_SDK_QT4" "$q"
1610 cnf_append "PATH_TOOL_QT4" "$q"
1611 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1612 return
1613 fi
1614 fi
1615 done
1616 fi
1617 fi
1618 else
1619 log_failure "qt4 not working"
1620 fail
1621 fi
1622 else
1623 log_failure "qt4 not found"
1624 fail
1625 fi
1626}
1627
1628
1629#
1630# Check whether static libstdc++ is installed. This library is required
1631# for the Linux guest additions.
1632#
1633check_staticlibstdcxx()
1634{
1635 test_header "static stc++ library"
1636 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1637 cat > $ODIR.tmp_src.cc << EOF
1638#include <string>
1639
1640extern "C" int main(void)
1641{
1642 std::string s = "test";
1643 return 0;
1644}
1645EOF
1646 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1647 log_success "found"
1648 fi
1649}
1650
1651
1652#
1653# Check for Linux sources
1654#
1655check_linux()
1656{
1657 test_header "Linux kernel sources"
1658 cat > $ODIR.tmp_src.c << EOF
1659#include <linux/version.h>
1660int printf(const char *format, ...);
1661int main(void)
1662{
1663 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1664 (LINUX_VERSION_CODE % 65536) / 256,
1665 LINUX_VERSION_CODE % 256);
1666#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1667 printf(", OK.\n");
1668 return 0;
1669#else
1670 printf(", expected version 2.4.0 or higher\n");
1671 return 1;
1672#endif
1673}
1674EOF
1675 echo "compiling the following source file:" >> $LOG
1676 cat $ODIR.tmp_src.c >> $LOG
1677 echo "using the following command line:" >> $LOG
1678 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
1679 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
1680 if [ $? -ne 0 ]; then
1681 echo
1682 echo " Linux kernel headers not found at $LINUX"
1683 echo " Check the file $LOG for detailed error information."
1684 fail
1685 else
1686 if test_execute; then
1687 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1688 fi
1689 fi
1690}
1691
1692
1693#
1694# Check for kchmviewer, needed to display the online help
1695# (unused as we ship kchmviewer)
1696#
1697check_kchmviewer()
1698{
1699 test_header kchmviewer
1700 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1701 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1702 if [ $? -ne 0 ]; then
1703 log_failure "kchmviewer not working"
1704 fail
1705 else
1706 log_success "found version $kchmviewer_ver"
1707 fi
1708 fi
1709}
1710
1711
1712#
1713# Check for the kBuild tools, we don't support GNU make
1714#
1715check_kbuild()
1716{
1717 test_header kBuild
1718 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1719 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1720 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1721 echo "export PATH_KBUILD" >> $ENV
1722 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1723 echo "export PATH_DEVTOOLS" >> $ENV
1724 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1725 echo "export PATH_KBUILD_BIN" >> $ENV
1726 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1727 if [ "$OS" = "solaris" ]; then
1728 # Because of sh being non-default shell in Solaris we need to export PATH again when
1729 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1730 echo "PATH=\"$ORGPATH\"" >> $ENV
1731 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1732 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1733 else
1734 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1735 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1736 fi
1737 echo "export PATH" >> $ENV
1738 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1739 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1740 elif [ "$OS.$BUILD_MACHINE" = "darwin.amd64" ]; then
1741 # Currently there are no amd64 kBuild bins. So use the x86 variant in any case.
1742 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.x86"
1743 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1744 echo "export PATH_KBUILD" >> $ENV
1745 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1746 echo "export PATH_DEVTOOLS" >> $ENV
1747 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.x86\"" >> $ENV
1748 echo "PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1749 echo "export PATH_KBUILD_BIN" >> $ENV
1750 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1751 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1752 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1753 echo "export PATH" >> $ENV
1754 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1755 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1756 elif check_avail "kmk" KBUILDDIR really; then
1757 # check for installed kBuild
1758 KBUILD_SED="`which_wrapper kmk_sed`"
1759 else
1760 fail
1761 fi
1762 log_success "found"
1763}
1764
1765
1766#
1767# Check for compiler.h
1768# Some Linux distributions include "compiler.h" in their libc linux
1769# headers package, some don't. Most don't need it, building might (!)
1770# not succeed on openSUSE without it.
1771#
1772# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1773#
1774check_compiler_h()
1775{
1776 test_header compiler.h
1777 if ! test -f "/usr/include/linux/compiler.h"; then
1778 log_success "compiler.h not found"
1779 else
1780 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1781 log_success "compiler.h found"
1782 fi
1783}
1784
1785#
1786# Check for libcap.
1787# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1788# sockets for doing ICMP requests.
1789#
1790check_libcap()
1791{
1792 test_header "libcap library"
1793 cat > $ODIR.tmp_src.cc << EOF
1794#include <cstdio>
1795#include <sys/types.h>
1796#include <linux/types.h>
1797#include <sys/capability.h>
1798
1799extern "C" int main(void)
1800{
1801 char buf[1024];
1802 cap_t caps = cap_get_proc();
1803 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1804 return 0;
1805}
1806EOF
1807 if test_compile $LIBCAP libcap libcap; then
1808 if test_execute; then
1809 log_success "found"
1810 fi
1811 fi
1812}
1813
1814#
1815# Check if we are able to build 32-bit applications (needed for the guest additions)
1816#
1817check_32bit()
1818{
1819 test_header "32-bit support"
1820 cat > $ODIR.tmp_src.c << EOF
1821#include <stdint.h>
1822int main(void)
1823{
1824 return 0;
1825}
1826EOF
1827 echo "compiling the following source file:" >> $LOG
1828 cat $ODIR.tmp_src.c >> $LOG
1829 echo "using the following command line:" >> $LOG
1830 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1831 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1832 if [ $? -ne 0 ]; then
1833 echo
1834 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1835 echo " Check the file $LOG for detailed error information."
1836 fail
1837 else
1838 echo "executing the binary" >> $LOG
1839 $ODIR.tmp_out 2> $ODIR.test_execute.log
1840 rc=$?
1841 cat $ODIR.test_execute.log >> $LOG
1842 if [ $rc -ne 0 ]; then
1843 echo
1844 echo " Cannot execute 32-bit applications! Either enable 32-bit support in the"
1845 echo " kernel configuration or use --disable-vmmraw to disable 32-bit guests."
1846 fail
1847 return 1
1848 fi
1849 fi
1850 log_success ""
1851}
1852
1853
1854#
1855# Check for Python
1856#
1857check_python()
1858{
1859 test_header "Python support"
1860
1861 # On darwin this is a on/off decision only
1862 if [ "$OS" = "darwin" ]; then
1863 echo "enabled"
1864 cnf_append "VBOX_WITH_PYTHON" "1"
1865 return
1866 fi
1867
1868 cat > $ODIR.tmp_src.cc << EOF
1869#include <cstdio>
1870#include <Python.h>
1871extern "C" int main(void)
1872{
1873 Py_Initialize();
1874 printf("found version %s", PY_VERSION);
1875#if PY_VERSION_HEX >= 0x02030000
1876 printf(", OK.\n");
1877 return 0;
1878#else
1879 printf(", expected version 2.3 or higher\n");
1880 return 1;
1881#endif
1882}
1883EOF
1884 found=
1885# For Solaris we use libpython2.4 for compatibility with Solaris 10 and passing IPS pkg audit
1886 if [ "$OS" != "solaris" ]; then
1887 SUPPYTHONLIBS="python2.7 python2.6 python2.5 python2.4 python2.3"
1888 else
1889 SUPPYTHONLIBS="python2.4"
1890 fi
1891 for p in $PYTHONDIR; do
1892 for d in $SUPPYTHONLIBS; do
1893 for b in lib64 lib/64 lib; do
1894 echo "compiling the following source file:" >> $LOG
1895 cat $ODIR.tmp_src.cc >> $LOG
1896 echo "using the following command line:" >> $LOG
1897 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1898 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1899 if [ $? -eq 0 ]; then
1900 found=1
1901 break
1902 fi
1903 done
1904 if [ -n "$found" ]; then break; fi
1905 done
1906 if [ -n "$found" ]; then break; fi
1907 done
1908 if [ -n "$found" ]; then
1909 if test_execute; then
1910 cnf_append "VBOX_WITH_PYTHON" "1"
1911 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
1912 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
1913 else
1914 log_failure "Python not working"
1915 fail
1916 fi
1917 else
1918 log_failure "Python not found"
1919 fail
1920 fi
1921}
1922
1923
1924#
1925# Check for Java
1926#
1927check_java()
1928{
1929 test_header "Java support"
1930 log_success
1931}
1932
1933
1934#
1935# Setup wine
1936#
1937setup_wine()
1938{
1939 test_header "Wine support"
1940 if ! which_wrapper wine > /dev/null; then
1941 echo " wine binary not found"
1942 fail
1943 fi
1944 if ! which_wrapper wine > /dev/null; then
1945 echo " wine not found"
1946 fail
1947 fi
1948 wine_version="`wine --version`"
1949 case "`expr "$wine_version" : 'wine-\([0-9.]*\)' '>' 1.1.43`" in
1950 "0")
1951 if ! which_wrapper wineprefixcreate > /dev/null; then
1952 echo " wineprefixcreate not found"
1953 fail
1954 fi
1955 ;;
1956 *) eval "wineprefixcreate() { true ; }" ;; # now created automatically
1957 esac
1958 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
1959 echo "WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
1960 echo "export WINEPREFIX" >> $ENV
1961 rm -rf $WINEPREFIX
1962 mkdir -p $WINEPREFIX
1963 touch $WINEPREFIX/.no_prelaunch_window_flag
1964 if ! wineprefixcreate -q > /dev/null 2>&1; then
1965 echo " wineprefixcreate failed"
1966 fail
1967 fi
1968 tmp=.tmp.wine.reg
1969 rm -f $tmp
1970 echo 'REGEDIT4' > $tmp
1971 echo '' >> $tmp
1972 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
1973 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
1974 echo '' >> $tmp
1975 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
1976 echo '"itss"="native"' >> $tmp
1977 echo '' >> $tmp
1978 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
1979 echo '"itss"="native"' >> $tmp
1980 echo '' >> $tmp
1981 if ! wine regedit $tmp > /dev/null 2>&1; then
1982 rm -f $tmp
1983 echo " failed to load registry changes (path)."
1984 fail
1985 fi
1986 rm -f $tmp
1987 log_success "found"
1988}
1989
1990
1991#
1992# Check for gSOAP.
1993#
1994check_gsoap()
1995{
1996 test_header "GSOAP compiler"
1997 if [ -z "$GSOAP" -a -z "$GSOAP_IMPORT" ]; then
1998 if which_wrapper pkg-config > /dev/null; then
1999 GSOAP_CXX_LIBS=`pkg-config gsoapssl++ --libs 2>> $LOG`
2000 if [ $? -eq 0 ]; then
2001 GSOAP=`pkg-config gsoapssl++ --variable=exec_prefix`
2002 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2003 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2004 GSOAP_IMPORT="$GSOAP/include/gsoap"
2005 fi
2006 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2007 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2008 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2009 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2010 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2011 else
2012 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2013 fi
2014 cnf_append "VBOX_GSOAP_CXX_LIBS" "`strip_l "$GSOAP_CXX_LIBS"`"
2015 gsoap_version=`pkg-config gsoapssl++ --modversion`
2016 log_success "found version $gsoap_version"
2017 return
2018 fi
2019 fi
2020 fi
2021 if [ -z "$GSOAP" ]; then
2022 GSOAP="/usr"
2023 fi
2024 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
2025 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
2026 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
2027 # TODO: Check for libgsoap++.a/so
2028
2029 if [ -z "$GSOAP_IMPORT" ]; then
2030 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2031 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2032 GSOAP_IMPORT="$GSOAP/include/gsoap"
2033 fi
2034 fi
2035 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
2036 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2037 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2038 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2039 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2040 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2041 else
2042 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2043 fi
2044 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoapssl++"
2045 log_success "found"
2046 else
2047 log_failure "stlvector.h not found -- disabling webservice"
2048 cnf_append "VBOX_WITH_WEBSERVICES" ""
2049 fi
2050 else
2051 log_failure "stdsoap2.h not found -- disabling webservice"
2052 cnf_append "VBOX_WITH_WEBSERVICES" ""
2053 fi
2054 else
2055 log_failure "wsdl2h not found -- disabling webservice"
2056 cnf_append "VBOX_WITH_WEBSERVICES" ""
2057 fi
2058 else
2059 log_failure "soapcpp2 not found -- disabling webservice"
2060 cnf_append "VBOX_WITH_WEBSERVICES" ""
2061 fi
2062}
2063
2064
2065#
2066# Determines the Darwin version.
2067# @todo This should really check the Xcode/SDK version.
2068#
2069check_darwinversion()
2070{
2071 test_header "Darwin version"
2072 darwin_ver=`uname -r`
2073 case "$darwin_ver" in
2074 11\.*)
2075 darwin_ver="10.7" # Lion
2076 sdk=/Developer/SDKs/MacOSX10.6.sdk
2077 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2078 ;;
2079 10\.*)
2080 darwin_ver="10.6" # Snow Leopard
2081 if [ "$BUILD_MACHINE" = "x86" ]; then
2082 sdk=/Developer/SDKs/MacOSX10.5.sdk
2083 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2084 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2085 else
2086 sdk=/Developer/SDKs/MacOSX10.6.sdk
2087 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2088 fi
2089# test "$CC" = "gcc" && CC="gcc-4.0"
2090# test "$CXX" = "g++" && CXX="g++-4.0"
2091 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2092 ;;
2093 9\.*)
2094 darwin_ver="10.5" # Leopard
2095 sdk=/Developer/SDKs/MacOSX10.5.sdk
2096 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2097# test "$CC" = "gcc" && CC="gcc-4.0"
2098# test "$CXX" = "g++" && CXX="g++-4.0"
2099 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2100 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2101 ;;
2102 8\.*)
2103 darwin_ver="10.4" # Tiger
2104 sdk=/Developer/SDKs/MacOSX10.4u.sdk
2105 CXX_FLAGS="-mmacosx-version-min=10.4 -isysroot $sdk -Wl,-syslibroot,$sdk"
2106# test "$CC" = "gcc" && CC="gcc-4.0"
2107# test "$CXX" = "g++" && CXX="g++-4.0"
2108 cnf_append "VBOX_WITH_COCOA_QT" ""
2109 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2110 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2111 ;;
2112 *)
2113 echo " failed to determine Darwin version. (uname -r: $darwin_ver)"
2114 fail
2115 darwin_ver="unknown"
2116 ;;
2117 esac
2118 log_success "found version $darwin_ver (SDK: $sdk)"
2119}
2120
2121
2122check_makeself()
2123{
2124 test_header "makeself"
2125 if check_avail "$MAKESELF" makeself; then
2126 makeself_ver=`$MAKESELF --version|grep version|sed 's+^Makeself.*version \([0-9\.]*\).*+\1+'`
2127 if [ $? -ne 0 ]; then
2128 log_failure "makeself not working"
2129 fail
2130 else
2131 log_success "found version $makeself_ver"
2132 cnf_append "VBOX_MAKESELF" "`which_wrapper $MAKESELF`"
2133 fi
2134 fi
2135}
2136
2137
2138#
2139# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
2140# is around to prevent confusion when the build fails in src/recompiler.
2141# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
2142#
2143check_i386elfgcc()
2144{
2145 test_header "i386-elf-gcc"
2146 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
2147 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
2148 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
2149 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
2150 if test -z "$i386_elf_gcc"; then
2151 echo " failed to find i386-elf-gcc"
2152 fail
2153 fi
2154 log_success "found $i386_elf_gcc"
2155}
2156
2157
2158#
2159# Show help
2160#
2161show_help()
2162{
2163cat << EOF
2164Usage: ./configure [OPTIONS]...
2165
2166Configuration:
2167 -h, --help display this help and exit
2168 --nofatal don't abort on errors
2169EOF
2170[ $WITH_XPCOM -eq 1 ] && echo " --disable-xpcom disable XPCOM and related stuff"
2171[ $WITH_PYTHON -eq 1 ] && echo " --disable-python disable python bindings"
2172[ $WITH_JAVA -eq 1 ] && echo " --disable-java disable java bindings"
2173[ $WITH_VMMRAW -eq 1 ] && echo " --disable-vmmraw disable VMM raw mode (VT-x/AMD-V mandatory!)"
2174[ $WITH_SDL_TTF -eq 1 ] && echo " --disable-sdl-ttf disable SDL_ttf detection"
2175[ $WITH_ALSA -eq 1 ] && echo " --disable-alsa disable the ALSA sound backend"
2176[ $WITH_PULSE -eq 1 ] && echo " --disable-pulse disable the PulseAudio backend"
2177[ $WITH_DBUS -eq 1 ] && echo " --disable-dbus don't use DBus and hal for hardware detection"
2178[ $WITH_KMODS -eq 1 ] && echo " --disable-kmods don't build Linux kernel modules (host and guest)"
2179[ $WITH_OPENGL -eq 1 ] && echo " --disable-opengl disable OpenGL support (2D & 3D)"
2180[ $WITH_GSOAP -eq 0 ] && echo " --enable-webservice enable the webservice stuff"
2181[ $OSE -eq 1 ] && echo " --enable-vnc enable the VNC server"
2182[ $OSE -eq 0 ] && echo " --disable-extpack don't build the extpack"
2183[ $WITH_DOCS -eq 1 ] && echo " --disable-docs don't build the documentation"
2184[ "$OS" = "linux" -o "$OS" = "freebsd" ] && echo " --enable-vde enable VDE networking"
2185cat << EOF
2186 --disable-udptunnel disable UDP tunnel networking
2187 --disable-hardening don't be strict about /dev/vboxdrv access
2188 --build-libxml2 build libxml2 from sources
2189EOF
2190[ $OSE -eq 0 ] && cat << EOF
2191 --build-libssl build openssl from sources
2192 --build-libcurl build libcurl from sources
2193EOF
2194[ "$OS" != "darwin" ] && echo " --setup-wine setup a Wine directory and register the hhc hack"
2195cat << EOF
2196
2197Paths:
2198 --with-gcc=PATH location of the gcc compiler [$CC]
2199 --with-g++=PATH location of the g++ compiler [$CXX]
2200 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
2201 --with-iasl=PATH location of the iasl compiler [$IASL]
2202 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
2203 --with-makeself=PATH location of makeself [$MAKESELF]
2204EOF
2205[ "$OS" = "linux" ] && echo " --with-linux=DIR Linux kernel source directory [$LINUX]"
2206[ $WITH_QT4 -eq 1 ] && echo " --with-qt-dir=DIR directory for Qt4 headers/libraries [pkgconfig]"
2207[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries"
2208[ $WITH_GSOAP -eq 1 ] && echo " (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)"
2209[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)"
2210cat << EOF
2211 --with-openssl-dir=DIR directory for OpenSSL headers/libraries
2212 --with-ow-dir=DIR directory where Open Watcom can be found [$WATCOM]
2213 --out-path=PATH the folder to which configuration and build output
2214 should go
2215
2216Build type:
2217 -d, --build-debug build with debugging symbols and assertions
2218 --build-profile build with profiling support
2219 --build-headless build headless (without any GUI frontend)
2220EOF
2221 exit 0
2222}
2223
2224
2225#
2226# The body.
2227#
2228
2229# test if we are OSE
2230if [ $OSE -eq 1 -a -r "`cd \`dirname $0\`; pwd`/src/VBox/RDP/server/server.cpp" ]; then
2231 OSE=0
2232 # Set this as a reminder to print a log message once we know the path of the
2233 # log file
2234 NOT_OSE=1
2235fi
2236
2237# Change OS specific defaults; must be before all other stuff
2238if [ "$OS" = "darwin" ]; then
2239 WITH_SDL=0
2240 WITH_SDL_TTF=0
2241 WITH_X11=0
2242 WITH_ALSA=0
2243 WITH_PULSE=0
2244 WITH_DBUS=0
2245 WITH_KMODS=0
2246 BUILD_LIBXML2=1
2247 [ $OSE -eq 1 ] || BUILD_LIBCURL=1
2248fi
2249
2250# scan command line options
2251for option in $*; do
2252 case "$option" in
2253 --help|-help|-h)
2254 show_help
2255 ;;
2256 --nofatal)
2257 nofatal=1
2258 ;;
2259 --env-only)
2260 ENV_ONLY=1
2261 ;;
2262 --with-gcc=*)
2263 CC=`echo $option | cut -d'=' -f2`
2264 ;;
2265 --with-g++=*)
2266 CXX=`echo $option | cut -d'=' -f2`
2267 ;;
2268 --with-kbuild=*)
2269 KBUILDDIR=`echo $option | cut -d'=' -f2`
2270 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
2271 echo "Error: KBUILDDIR contains invalid characters!"
2272 exit 1
2273 fi
2274 ;;
2275 --with-qt-dir=*|--with-qt4-dir=*)
2276 QT4DIR=`echo $option | cut -d'=' -f2`
2277 QT4DIR_PKGCONFIG=0
2278 ;;
2279 --with-openssl-dir=*)
2280 OPENSSLDIR=`echo $option | cut -d'=' -f2`
2281 INCCRYPTO="-I${OPENSSLDIR}/include"
2282 LIBCRYPTO="${OPENSSLDIR}/lib/libcrypto.a ${OPENSSLDIR}/lib/libssl.a"
2283 ;;
2284 --with-ow-dir=*)
2285 WATCOM=`echo $option | cut -d'=' -f2`
2286 ;;
2287 --with-gsoap-dir=*)
2288 GSOAP=`echo $option | cut -d'=' -f2`
2289 ;;
2290 --with-gsoap-import=*)
2291 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
2292 ;;
2293 --with-iasl=*)
2294 IASL=`echo $option | cut -d'=' -f2`
2295 ;;
2296 --with-linux=*)
2297 LINUX=`echo $option | cut -d'=' -f2`
2298 ;;
2299 --with-mkisofs=*)
2300 MKISOFS=`echo $option | cut -d'=' -f2`
2301 ;;
2302 --with-makeself=*)
2303 MAKESELF=`echo $option | cut -d'=' -f2`
2304 ;;
2305 --target-arch=*)
2306 TARGET_MACHINE=`echo $option | cut -d'=' -f2`
2307 ;;
2308 --disable-xpcom)
2309 [ $WITH_XPCOM -eq 1 ] && WITH_XPCOM=0
2310 ;;
2311 --disable-python)
2312 [ $WITH_PYTHON -eq 1 ] && WITH_PYTHON=0
2313 ;;
2314 --disable-java)
2315 [ $WITH_JAVA -eq 1 ] && WITH_JAVA=0
2316 ;;
2317 --disable-vmmraw)
2318 [ $WITH_VMMRAW -eq 1 ] && WITH_VMMRAW=0
2319 ;;
2320 --disable-sdl-ttf)
2321 [ $WITH_SDL_TTF -eq 1 ] && WITH_SDL_TTF=0
2322 ;;
2323 --disable-qt)
2324 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2325 ;;
2326 --disable-qt4)
2327 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2328 ;;
2329 --passive-mesa)
2330 PASSIVE_MESA=1
2331 ;;
2332 --disable-alsa)
2333 [ $WITH_ALSA -eq 1 ] && WITH_ALSA=0
2334 ;;
2335 --disable-pulse)
2336 [ $WITH_PULSE -eq 1 ] && WITH_PULSE=0
2337 ;;
2338 --enable-pulse)
2339 WITH_PULSE=2
2340 ;;
2341 --disable-dbus)
2342 [ $WITH_DBUS -eq 1 ] && WITH_DBUS=0
2343 ;;
2344 --disable-kmods)
2345 [ $WITH_KMODS -eq 1 ] && WITH_KMODS=0
2346 ;;
2347 --disable-opengl)
2348 [ $WITH_OPENGL -eq 1 ] && WITH_OPENGL=0
2349 ;;
2350 --enable-webservice)
2351 [ $WITH_GSOAP -eq 0 ] && WITH_GSOAP=1
2352 ;;
2353 --enable-vnc)
2354 WITH_VNC=1
2355 ;;
2356 --disable-hardening)
2357 WITH_HARDENING=0
2358 ;;
2359 --disable-extpack)
2360 WITH_EXTPACK=0
2361 ;;
2362 --disable-docs)
2363 WITH_DOCS=0
2364 ;;
2365 --enable-hardening)
2366 WITH_HARDENING=2
2367 ;;
2368 --disable-udptunnel)
2369 WITH_UDPTUNNEL=0
2370 ;;
2371 --enable-vde)
2372 WITH_VDE=1
2373 ;;
2374 --build-debug|-d)
2375 BUILD_TYPE=debug
2376 ;;
2377 --build-profile)
2378 BUILD_TYPE=profile
2379 ;;
2380 --build-libxml2)
2381 BUILD_LIBXML2=1
2382 ;;
2383 --build-libssl)
2384 BUILD_LIBSSL=1
2385 ;;
2386 --build-libcurl)
2387 BUILD_LIBCURL=1
2388 ;;
2389 --build-headless)
2390 HEADLESS=1
2391 WITH_SDL=0
2392 WITH_SDL_TTF=0
2393 WITH_X11=0
2394 WITH_OPENGL=0
2395 WITH_QT4=0
2396 ;;
2397 --ose)
2398 OSE=2
2399 ;;
2400 --odir=*)
2401 ODIR="`echo $option | cut -d'=' -f2`/"
2402 ODIR_OVERRIDE=1
2403 ;;
2404 --out-path=*)
2405 out_path="`echo $option | cut -d'=' -f2`/"
2406 if [ -d $out_path ]; then
2407 saved_path="`pwd`"
2408 cd $out_path
2409 OUT_PATH="`pwd`"
2410 cd $saved_path
2411 OUT_PATH_OVERRIDE=1
2412 if [ $ODIR_OVERRIDE -eq 0 ]; then
2413 # This variable has not *yet* been overridden. That can still happen.
2414 ODIR=$OUT_PATH/
2415 fi
2416 else
2417 echo "Error: invalid folder \"$out_path\" in option \"$option\""
2418 exit 1
2419 fi
2420 ;;
2421 --setup-wine)
2422 [ "$OS" != "darwin" ] && SETUP_WINE=1
2423 ;;
2424 *)
2425 echo
2426 echo "Unrecognized option \"$option\""
2427 echo
2428 show_help
2429 ;;
2430 esac
2431done
2432
2433LOG="$ODIR$LOG"
2434ENV="$ODIR$ENV"
2435CNF="$ODIR$CNF"
2436
2437# initialize output files
2438cat > $LOG << EOF
2439# Log file generated by
2440#
2441# '$0 $*'
2442#
2443
2444EOF
2445cat > $CNF << EOF
2446# -*- Makefile -*-
2447#
2448# automatically generated by
2449#
2450# '$0 $*'
2451#
2452# It will be completely overwritten if configure is executed again.
2453#
2454
2455EOF
2456cat > $ENV << EOF
2457#!/bin/bash
2458#
2459# automatically generated by
2460#
2461# '$0 $*'
2462#
2463# It will be completely overwritten if configure is executed again.
2464# Make sure you source this file once before you start to build VBox.
2465#
2466
2467EOF
2468
2469# Print log warning about OSE if necessary
2470if [ -n "$NOT_OSE" ]; then
2471 echo "Found RDP server, assuming VBOX_OSE = FALSE" >> $LOG
2472 echo >> $LOG
2473fi
2474
2475
2476if [ "$BUILD_TYPE" = "debug" ]; then
2477 echo "Creating DEBUG build!" >> $LOG
2478elif [ "$BUILD_TYPE" = "profile" ]; then
2479 echo "Creating PROFILE build!" >> $LOG
2480fi
2481
2482# first determine our environment
2483check_environment
2484check_kbuild
2485
2486[ -n "$ENV_ONLY" ] && exit 0
2487
2488# append the tools directory to the default search path
2489echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2490export PATH
2491
2492# if we will be writing to a different out directory then set this up now
2493if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2494 echo "AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2495 echo "export AUTOCFG" >> $ENV
2496 echo "LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2497 echo "export LOCALCFG" >> $ENV
2498 echo "PATH_OUT_BASE=$OUT_PATH" >> $ENV
2499 echo "export PATH_OUT_BASE" >> $ENV
2500fi
2501
2502# some things are not available in for OSE
2503if [ $OSE -ge 1 ]; then
2504 cnf_append "VBOX_OSE" "1"
2505 cnf_append "VBOX_WITH_TESTSUITE" ""
2506 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2507
2508 if [ "$OS" = "linux" ]; then
2509 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2510 else
2511 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2512 fi
2513 echo >> $CNF
2514fi
2515
2516# extpack
2517if [ $OSE -eq 0 ]; then
2518 if [ $WITH_EXTPACK -eq 1 ]; then
2519 BUILD_LIBSSL=1
2520 else
2521 cnf_append "VBOX_WITH_EXTPACK_PUEL_BUILD" ""
2522 fi
2523fi
2524
2525# headless
2526if [ -n "$HEADLESS" ]; then
2527 cnf_append "VBOX_HEADLESS" "1"
2528fi
2529
2530# emit disable directives corresponding to any --disable-xxx options.
2531if [ $WITH_OPENGL -eq 0 ]; then
2532 cnf_append "VBOX_WITH_CROGL" ""
2533 cnf_append "VBOX_WITH_VIDEOHWACCEL" ""
2534 cnf_append "VBOX_GUI_USE_QGL" ""
2535fi
2536[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2537[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2538[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2539[ $WITH_PYTHON -eq 0 ] && cnf_append "VBOX_WITH_PYTHON" ""
2540[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JXPCOM" ""
2541[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JWS" ""
2542[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2543[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2544[ $WITH_VMMRAW -eq 0 ] && cnf_append "VBOX_WITH_RAW_MODE" ""
2545
2546# Darwin-specific
2547if [ "$OS" = "darwin" ]; then
2548 check_darwinversion
2549fi
2550# the tools
2551check_gcc
2552[ "$OS" != "darwin" ] && check_as86
2553[ "$OS" != "darwin" ] && check_bcc
2554check_open_watcom
2555[ "$OS" != "darwin" ] && check_iasl
2556# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2557# [ "$OS" != "darwin" ] && check_yasm
2558[ "$OS" != "darwin" ] && check_xsltproc
2559[ "$OS" != "darwin" ] && check_mkisofs
2560
2561# the libraries
2562[ "$OS" != "darwin" ] && check_pthread
2563check_libxml2
2564[ $WITH_LIBIDL -eq 1 ] && check_libidl
2565check_ssl
2566check_curl
2567[ "$OS" != "darwin" ] && check_z
2568[ "$OS" != "darwin" ] && check_png
2569[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2570[ $WITH_SDL -eq 1 ] && check_sdl
2571[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2572[ $WITH_X11 -eq 1 ] && check_x
2573# TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2574# TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2575[ $WITH_X11 -eq 1 ] && check_xcursor
2576[ $WITH_X11 -eq 1 ] && check_xinerama
2577[ $WITH_X11 -eq 1 ] && check_xrandr
2578[ $WITH_OPENGL -eq 1 ] && check_opengl
2579[ $WITH_QT4 -eq 1 ] && check_qt4
2580[ $WITH_PYTHON -eq 1 ] && check_python
2581[ $WITH_JAVA -eq 1 ] && check_java
2582
2583# PulseAudio
2584if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2585 if [ $WITH_PULSE -eq 1 ]; then
2586 check_pulse
2587 elif [ $WITH_PULSE -eq 0 ]; then
2588 cnf_append "VBOX_WITH_PULSE" ""
2589 fi
2590fi
2591
2592# Linux-specific
2593if [ "$OS" = "linux" ]; then
2594 # don't check for the static libstdc++ in the PUEL version as we build the
2595 # additions at a dedicated box
2596 [ $OSE -ge 1 ] && check_staticlibstdcxx
2597 if [ $WITH_KMODS -eq 1 ]; then
2598 check_linux
2599 else
2600 cnf_append "VBOX_LINUX_SRC" ""
2601 cnf_append "VBOX_WITH_VBOXDRV" ""
2602 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
2603 fi
2604 if [ $WITH_ALSA -eq 1 ]; then
2605 check_alsa
2606 else
2607 cnf_append "VBOX_WITH_ALSA" ""
2608 fi
2609 if [ $WITH_DBUS -eq 0 ]; then
2610 cnf_append "VBOX_WITH_DBUS" ""
2611 fi
2612 check_libcap
2613 check_compiler_h
2614 [ "$BUILD_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 1 ] && check_32bit
2615 # tools/common/makeself*
2616 [ $OSE -ge 1 ] && check_makeself
2617fi
2618
2619[ -n "$SETUP_WINE" ] && setup_wine
2620
2621if [ $OSE -ge 1 ]; then
2622 if [ $WITH_GSOAP -eq 1 ]; then
2623 check_gsoap
2624 else
2625 cnf_append "VBOX_WITH_WEBSERVICES" ""
2626 fi
2627fi
2628
2629# UDPTUNNEL
2630if [ $WITH_UDPTUNNEL -eq 0 ]; then
2631 cnf_append "VBOX_WITH_UDPTUNNEL" ""
2632fi
2633
2634# VDE
2635if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2636 if [ $WITH_VDE -eq 1 ]; then
2637 cnf_append "VBOX_WITH_VDE" "1"
2638 fi
2639fi
2640
2641# DOCS
2642if [ $WITH_DOCS -eq 0 ]; then
2643 cnf_append "VBOX_WITH_DOCS" ""
2644 cnf_append "VBOX_WITH_DOCS_PACKING" ""
2645fi
2646
2647# VNC server support
2648if [ $OSE -ge 1 ]; then
2649 if [ $WITH_VNC = 1 ]; then
2650 check_vncserver
2651 else
2652 cnf_append "VBOX_WITH_EXTPACK_VNC" ""
2653 fi
2654fi
2655
2656# success!
2657echo
2658echo "Successfully generated '$CNF' and '$ENV'."
2659echo "Source '$ENV' once before you start to build VBox:"
2660echo ""
2661echo " source $ENV"
2662echo " kmk"
2663echo ""
2664if [ "$OS" = "linux" ]; then
2665 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2666 vbox_out_path=$OUT_PATH
2667 else
2668 vbox_out_path=./out
2669 fi
2670 echo "To compile the kernel modules, do:"
2671 echo ""
2672 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
2673 echo " make"
2674 echo ""
2675fi
2676if [ $WITH_HARDENING -gt 0 ]; then
2677 echo ""
2678 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2679 echo " Hardening is enabled which means that the VBox binaries will not run from"
2680 echo " the binary directory. The binaries have to be installed suid root and some"
2681 echo " more prerequisites have to be fulfilled which is normally done by installing"
2682 echo " the final package. For development, the hardening feature can be disabled"
2683 echo " by specifying the --disable-hardening parameter. Please never disable that"
2684 echo " feature for the final distribution!"
2685 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2686 echo ""
2687else
2688 echo ""
2689 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2690 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2691 echo " disabled hardening!"
2692 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2693 echo ""
2694fi
2695echo "Enjoy!"
2696cleanup
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use